/*
 * dma.c
 *
 * Created: 23.09.2018 17:11:19
 *  Author: Thomas F
 */ 

#include <stdbool.h>
#include "sam.h"

#include "clocks.h"
#include "misc.h"
#include "IO.h"
#include "dma.h"


// DMA descriptors for all users
DmacDescriptors_t WsDmacDescriptors;



void DmaInit(void)
{
	// Enable module clock for DMAC (is on by default)
	//MCLK->AHBMASK.bit.DMAC_ = true;


	// Configure registers DMAC must disabled
	DMAC->BASEADDR.reg = (uint32_t)&WsDmacDescriptors.C0D1;
	DMAC->WRBADDR.reg = (uint32_t)&WsDmacDescriptors.C0WB[0];
	
	DMAC->PRICTRL0.reg = (!DMAC_PRICTRL0_RRLVLEN3) | DMAC_PRICTRL0_QOS3_CRITICAL	// WS Port DMA (Round-Robin off)
					   | (DMAC_PRICTRL0_RRLVLEN2) | DMAC_PRICTRL0_QOS2_REGULAR		
					   | (DMAC_PRICTRL0_RRLVLEN1) | DMAC_PRICTRL0_QOS1_REGULAR		
					   | (DMAC_PRICTRL0_RRLVLEN0) | DMAC_PRICTRL0_QOS0_REGULAR;
	
	DMAC->CTRL.reg = DMAC_CTRL_LVLEN3 | (!DMAC_CTRL_LVLEN2) | (!DMAC_CTRL_LVLEN1) | (!DMAC_CTRL_LVLEN0) | DMAC_CTRL_DMAENABLE;
}


